#include <cassert>
#include <cstdio>
#include <cmath>
#include <cstdlib>

#include "AuxRND.h"
#ifdef __USE_MERSENNE_TWISTER
#include "mtwister.h"
#endif // __USE_MERSENNE_TWISTER

static MTRand MersenneTwister;

void
MersenneTwisterSetSeed(int newSeed)
{
//  MersenneTwister.SetSeed(newSeed);
  MersenneTwister.seed(newSeed);
}

double
MersenneTwisterRand()
{
  const float epsilon = 1e-6;

  float value = MersenneTwister.randExc();
  if (value < 0.0) {
    value = 0.0;
    //FATAL << "MersenneTwister bad down" << endl;
  }
  if (value >= 1.0) {
    value = 1.0 - epsilon;
    //FATAL << "MersenneTwister bad up" << endl;
  }
  return value;
}


