// ===================================================================
// $Id$
//
// strings.h
//    String constants used across the whole library, usually for BRDF
//    parameters description.
//
// Class: CSchlickSurvey94
//
// Initial coding by Jiri Nekola, November 2010.

#ifndef __STRINGS_H__
#define __STRINGS_H__

// BRDFLIB library
#include "configh.h"

__BEGIN_BRDFLIB_HEADER

namespace BrdfStrings {

// BRDF models descriptions
extern const char* KPhongDesc;
extern const char* KPhongPhysicalDesc;
extern const char* KAnisoPhongDesc;
extern const char* KPhongPhysicalDRDesc;
extern const char* KPhongGrazingMirrorDesc;
extern const char* KMicrofacetDesc;
extern const char* KAnisoWardDesc;
extern const char* KIsoWardDesc;
extern const char* KAnisoWardDuerDesc;
extern const char* KIsoWardDuerDesc;
extern const char* KAnisoMoroderDuerDesc;
extern const char* KIsoMoroderDuerDesc;
extern const char* KBeardMaxwellDesc;
extern const char* KCookTorranceDesc;
extern const char* KSchlickSurveyDesc;
extern const char* KSimpleCookTorranceDesc;
extern const char* KCoupledModelDesc;
extern const char* KLafortuneDesc;
extern const char* K_MGF_Desc;
extern const char* KIdealDiffuseReflDesc;
extern const char* KIdealMirrorReflDesc;
extern const char* KIdealMetalDesc;
extern const char* KSpecularReflectorDesc;
extern const char* KIdealDiffuseRefrDesc;
extern const char* KIdealRefractorDesc;
extern const char* KIdealDielectricDesc;
extern const char* KOrenNayarDesc;
extern const char* KMinnaertDesc;
extern const char* KKurtKalosAnisoDesc;
extern const char* KKurtKalosIsoDesc;
extern const char* KNeumannDesc;
extern const char* KLayeredMixtureDesc;


// BRDF model parameters titles & descriptions
extern const char* KInvalidParameter;

extern const char* KAmbientTitle;
extern const char* KDiffuseTitle;
extern const char* KSpecularTitle;
extern const char* KShininessTitle;
extern const char* KDiffuseReflTitle;
extern const char* KSpecularReflTitle;
extern const char* KShininessReflTitle;
extern const char* KDiffuseRefrTitle;
extern const char* KSpecularRefrTitle;
extern const char* KShininessRefrTitle;
extern const char* KRefractionTitle;
extern const char* KIORTitle;
extern const char* KExtinctionCoefTitle;
extern const char* KMaxPhongTitle;
extern const char* KMaxWardTitle;
extern const char* KWardDuerTitle;
extern const char* KMoroderDuerTitle;
extern const char* KMaxLafTitle;
extern const char* KBlinnNormalsTitle;
extern const char* KRetroReflectiveTitle;
extern const char* KSlopeTitle;
extern const char* KSlopeXTitle;
extern const char* KSlopeYTitle;
extern const char* KSlopeWeightTitle;
extern const char* KSlopeWeightXTitle;
extern const char* KSlopeWeightYTitle;
extern const char* KVolumeTitle;
extern const char* KFresnelTitle;
extern const char* KLobeTitle;
extern const char* KAlbedoTitle;
extern const char* KSchlickApproxTitle;
extern const char* KAnisotropyTitle;
extern const char* KAlphaTitle;
extern const char* KLimbDarkTitle;
extern const char* KLayerTitle;

extern const char* KAlbedoDesc;
extern const char* KDiffuseDesc;
extern const char* KSpecularDesc;
extern const char* KShininessDesc;
extern const char* KDiffuseReflDesc;
extern const char* KSpecularReflDesc;
extern const char* KShininessReflDesc;
extern const char* KDiffuseRefrDesc;
extern const char* KSpecularRefrDesc;
extern const char* KShininessRefrDesc;
extern const char* KRefractionDesc;
extern const char* KIORDesc;
extern const char* KExtinctionCoefDesc;
extern const char* KMaxPhongDesc;
extern const char* KMaxWardDesc;
extern const char* KMaxLafDesc;
extern const char* KBlinnNormalsDesc;
extern const char* KRetroReflectiveDesc;
extern const char* KSlopeDesc;
extern const char* KSlopeXDesc;
extern const char* KSlopeYDesc;
extern const char* KVolumeDesc;
extern const char* KFresnelDesc;
extern const char* KLobeDesc;
extern const char* KSchlickApproxDesc;
extern const char* KAnisotropyDesc;
extern const char* KSlopeONDesc; 
extern const char* KAlphaDesc;
extern const char* KLimbDarkDesc;
extern const char* KLayerDesc;
} // namespace

__END_BRDFLIB_HEADER

#endif // __STRINGS_H__
